/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package tp2;

import java.io.Serializable;
import java.lang.annotation.Target;
import java.util.ArrayList;
import java.util.Collection;
import javax.persistence.CascadeType;
import javax.persistence.DiscriminatorColumn;
import javax.persistence.DiscriminatorType;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;

/**
 *
 * @author Pierrick
 */
@Entity(name="CompteBancaire")
@Inheritance(strategy=InheritanceType.SINGLE_TABLE)
@DiscriminatorColumn(name="DISC", discriminatorType=DiscriminatorType.STRING)
@DiscriminatorValue("CompteBancaire")
public class CompteBancaire implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    protected int id;
    
    @ManyToOne
    protected Proprietaire proprietaire;
    protected int solde;

    @OneToMany(cascade={CascadeType.ALL}, fetch=FetchType.EAGER)
    protected Collection<OperationBancaire> operations = new ArrayList();

    public Collection<OperationBancaire> getOperations() {
        return operations;
    }

    public void setOperations(Collection<OperationBancaire> operations) {
        this.operations = operations;
    }

    public CompteBancaire() {
    }

    public CompteBancaire(Proprietaire proprietaire, int solde) {
        this.proprietaire = proprietaire;
        this.solde = solde;
    }

    public CompteBancaire creerCompte(Proprietaire p, int s) {
        CompteBancaire c = new CompteBancaire(p, s);
        return c;
    }

    public int consulter() {
        return solde;
    }

    public int deposer(int montant) {
        solde += montant;
        return montant;
    }

    public int retirer(int montant) {
        if (montant > solde) {
            return 0;
        } else {
            solde -= montant;
            return montant;
        }
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public Proprietaire getProprietaire() {
        return proprietaire;
    }

    public void setProprietaire(Proprietaire proprietaire) {
        this.proprietaire = proprietaire;
    }

    public double getSolde() {
        return solde;
    }

    public void setSolde(int solde) {
        this.solde = solde;
    }

    @Override
    public String toString() {
        return "tp2.CompteBancaire[id=" + id + "]";
    }
}
